z=300;
t  = linspace(0,3,z);

s = poly(0,"s");
pa=0.0246580;
pb=7.9769475;
pc=280.08032;
G = syslin('c',[1],[pa*s*s+pb*s+pc]);
u = 300*ones(z,1);

y   = csim(u',t',G);
//plot(t,y(1,:),t,om);


disp("Mit zusätzlichem Integrator um Übertragungsfunktion für Winkel zu bekommen:");

GI = syslin('c',[1],[pa*s*s*s+pb*s*s+pc*s]);
yi = csim(u',t',GI);

//plot(t,yi(1,:),'re',t,phi,'gre',m1(:,1),-m1(:,2)+0.12,'blu');

rp=1200.0;
ri=16.0;

//R=rp+ri/s=(rp*s+ri)/s

R = syslin('c',[rp*s+ri],[s]);

H = R*GI;
Q = H/(1+H);

z=300;
u  = 0.2*ones(z,1);
t  = linspace(0,3,z);
yq = csim(u',t',Q);

//plot(t,yq);

function err=berechneFehler(x)
    rp=x(1);
    ri=x(2);

    R = syslin('c',[rp*s+ri],[s]);
    H = R*GI;
    Q = H/(1+H);

    yq = csim(u',t',Q);
    
    err = sum((yq(1,:)-u').*(yq(1,:)-u'));
endfunction

rp=1200.0;
ri=16.0;

x0=[rp;ri];

[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);

rp=xopt(1);
ri=xopt(2);

R = syslin('c',[rp*s+ri],[s]);
H = R*GI;
Q = H/(1+H);
yq = csim(u',t',Q);

plot(t,yq(1,:)');

//Ergebnis mit Startwerten mit anzeigen:

rp=1200.0;
ri=16.0;

R = syslin('c',[rp*s+ri],[s]);
H = R*GI;
Q = H/(1+H);
yq = csim(u',t',Q);

plot(t,yq(1,:)');







