clear();

pa=0.0246580;
pb=7.9769475;
pc=280.08032;
z=300;
u  = 0.2*ones(z,1);
t  = linspace(0,3,z);

//------------------------------
//GI mit PI-Regler im Zeitbereich abbilden:
//Jetzt Integral von phisoll - phi mitführen:
//(phisoll=0.2)
PHISOLL=0.2;
Agii=[   0,-1, 0,    0;
         0, 0, 1,    0;
         0, 0, 0,    1;
         0, 0,-pc/pa,-pb/pa];

Bgii=[1,0,0,0;
      0,0,0,0;
      0,0,0,0;
      0,0,0,1/pa];

//rp=1200.0;
//ri=16.0;
rp=500.0;
ri=100.0;

u_begrenzt_tot=0; //wird später berechnet, muß aber hier deklariert werden, da in rechteSeiteGIR gebraucht.

function f = rechteSeiteGIR(t,yy)
    w       = PHISOLL-yy(2);
    w_integ = yy(1); 

    //u_begrenzt = rp*w + ri*w_integ;

    u_begrenzt = u_begrenzt_tot; //um Totzeit verzögertes Signal verwenden.


    if u_begrenzt>500 then
        u_begrenzt=500;
    end

    if u_begrenzt<-500 then
        u_begrenzt=-500;
    end

    u_sim   = [PHISOLL;0;0;u_begrenzt]; 
    f = Agii*yy+Bgii*u_sim; 
endfunction

y0 = [0,0,0,0]'; 
t0 = 0;
ygir_sim  = ode(y0,t0,t,rechteSeiteGIR);

//plot(t,ygir_sim(2,:),'gre',t,yq,'red--');


//-----------------------------------
//Definition Runge-Kutta-Integrator

modell=rechteSeiteGIR;
function yneu=ruku(y,t,dt)
       k1=modell(t,y);
       k2=modell(t+0.5*dt,y+0.5.*dt.*k1);
       k3=modell(t+0.5*dt,y+0.5.*dt.*k2);
       k4=modell(t+dt,y+dt.*k3);
       yneu=y+dt.*(k1+2.*k2+2.*k3+k4)./6;
endfunction

//-----------------------------------
//Optimierung:

//Erzeugen von Normal verteilten Zufallszahlen mit Mittelwert mi und Streuung st
mi=0.0;
st=0.01;
zuf = grand(1, 1, "nor", mi, st);

talt=t;
ygir_sim_alt = ygir_sim;

z=900; //Erhöhung nötig, sonst RuKu zu ungenau!
u  = 0.2*ones(z,1);
t  = linspace(0,3,z);
dt = t(2)-t(1);

Tt = 0.0150984; //Identifizierte Totzeit in Sekunden.

//Anzahl der Simulationsschritte, bis die Totzeit vorbei ist:
anztt = round(Tt/dt);


u_merk = [0];

function err=berechneFehler(x)
    rp=x(1);
    ri=x(2);

    y0 = [0,0,0,0]'; 
    t0 = 0;

    //vorher:
    //ygir_sim  = ode(y0,t0,t,rechteSeiteGIR);

    //jetzt:
    //Simulation mit Runge-Kutta
    yalt = y0;
    ygir_sim = yalt;

    u_begrenzt_aktuell = 0;
    u_merk = [0];

    index_umerk = 1;

    w_integ=0.0;

    for i=1:1:z-1
        takt = t(i);
        yneu=ruku(yalt,takt,dt);
        yalt=yneu;
        ygir_sim=[ygir_sim,yalt];

        //Stellsignal rekonstruieren:
       zuf1 = grand(1, 1, "nor", mi, st);
       zuf2 = grand(1, 1, "nor", mi, st);
       //zuf1 = 0;
       //zuf2 = 0;

        w       = PHISOLL-yalt(2) + zuf1;  //Normal verteiltes Rauschen hinzufügen
        //w_integ = yalt(1); 
        w_integ = w_integ + w*dt; //Integral numerisch berechnen. 

        u_begrenzt_aktuell = rp*w + ri*w_integ;
        if u_begrenzt_aktuell>500 then
            u_begrenzt_aktuell=500;
        end

        if u_begrenzt_aktuell<-500 then
            u_begrenzt_aktuell=-500;
        end

        //In Array merken:
        u_merk = [u_merk,u_begrenzt_aktuell];

        //Anfangen aus den gemerkten Werten zu lesen, wenn die Totzeit vorbei ist:
        if i>=anztt
             u_begrenzt_tot = u_merk(index_umerk);
             index_umerk=index_umerk+1;
        end
    end

    //Achtung: phi ist der zweite Zustand (der erste ist das Integral von -phi).
    err = sum((ygir_sim(2,1:z)-u(1:z,1)').*(ygir_sim(2,1:z)-u(1:z,1)'));
    //err = u_merk; //Tests
endfunction

function bestparam = meinoptimierer(fehlerfunktion,startparam,minparam,maxparam)
    x0 = startparam;
    deltax = (maxparam-minparam).*0.0001;
    xakt=x0;

    sx = size(x0);
    zx = sx(1);

    fehler_akt = fehlerfunktion(x0);

    for i=1:100
        k = grand(1, 1, "uin", 1, zx);
        xneu = xakt;
        if xneu(k)+deltax(k)<maxparam(k) & xneu(k)-deltax(k)>minparam(k) then
            xneu(k)=xneu(k)+deltax(k);
            fehler_neu_plus = fehlerfunktion(xneu);
            xneu = xakt;
            xneu(k)=xneu(k)-deltax(k);
            fehler_neu_minus = fehlerfunktion(xneu);
 
            if fehler_neu_plus<fehler_akt then
                fehler_akt=fehler_neu_plus;
                xakt(k)=xakt(k)+deltax(k);
                deltax(k) = deltax(k)*1.01;
            elseif fehler_neu_minus<fehler_akt then
                fehler_akt=fehler_neu_minus;
                xakt(k)=xakt(k)-deltax(k);
                deltax(k) = deltax(k)*1.01;
            else
                deltax(k) = deltax(k)*0.99;
            end
        end
    end    

    bestparam = xakt;
endfunction


rp=500.0;
ri=100.0;

x0=[rp;ri];

//[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.001, x0.*1000.0, x0);
xopt = meinoptimierer(berechneFehler,x0,x0.*0.001, x0.*1000.0);

rp=xopt(1);
ri=xopt(2);
y0 = [0,0,0,0]'; 
t0 = 0;



//ygir_simopt  = ode(y0,t0,t,rechteSeiteGIR);
//------- Kopie aus Fehlerfunktion ---------

//    rp=x(1);
//    ri=x(2);

    y0 = [0,0,0,0]'; 
    t0 = 0;

    //vorher:
    //ygir_sim  = ode(y0,t0,t,rechteSeiteGIR);

    //jetzt:
    //Simulation mit Runge-Kutta
    yalt = y0;
    ygir_sim = yalt;

    u_begrenzt_aktuell = 0;
    u_merk = [0];

    index_umerk = 1;

    w_integ=0.0;

    for i=1:1:z-1
        takt = t(i);
        yneu=ruku(yalt,takt,dt);
        yalt=yneu;
        ygir_sim=[ygir_sim,yalt];

        //Stellsignal rekonstruieren:
       zuf1 = grand(1, 1, "nor", mi, st);
       zuf2 = grand(1, 1, "nor", mi, st);

        w       = PHISOLL-yalt(2) + zuf1;  //Normal verteiltes Rauschen hinzufügen
        //w_integ = yalt(1); 
        w_integ = w_integ + w*dt; //Integral numerisch berechnen. 

        u_begrenzt_aktuell = rp*w + ri*w_integ;
        if u_begrenzt_aktuell>500 then
            u_begrenzt_aktuell=500;
        end

        if u_begrenzt_aktuell<-500 then
            u_begrenzt_aktuell=-500;
        end

        //In Array merken:
        u_merk = [u_merk,u_begrenzt_aktuell];

        //Anfangen aus den gemerkten Werten zu lesen, wenn die Totzeit vorbei ist:
        if i>=anztt
             u_begrenzt_tot = u_merk(index_umerk);
             index_umerk=index_umerk+1;
        end
    end


//--------Ende Kopie -----------------------


plot(t,ygir_sim(2,:),'blu');

disp(rp);
disp(ri);



