disp("Verifizierung der Winkelgeschw. mittels des Winkels:");

t0=ma(2,1);
t=ma(:,1)-t0;
t=t*0.000001;
zs=size(ma);
z=zs(1);
m1=[t(1:z),ma(1:z,2),ma(1:z,3)];
t0=mb(2,1);
t=mb(:,1)-t0;
t=t*0.000001;
zs=size(mb);
z=zs(1);
m2=[t(1:z),mb(1:z,2),mb(1:z,3)];
t0=mc(2,1);
t=mc(:,1)-t0;
t=t*0.000001;
zs=size(mc);
z=zs(1);
m3=[t(1:z),mc(1:z,2),mc(1:z,3)];

tt=[m1(:,1);m2(:,1);m3(:,1)];
tmax=max(tt);

t=linspace(0,tmax,50);


om1=interp1(m1(:,1),m1(:,3),t,'linear');
om3=interp1(m3(:,1),m3(:,3),t,'linear');


//plot(t,om1);
//plot(t,om3);

//Totzeit bestimmen:
//plot(t(5:50),om1(5:50));
totzeit=t(5)
disp("Totzeit:");
disp(totzeit);

//Korrigieren:
om11 = om1(5:50)-om1(5);
om33 = om3(5:50)-om3(5);
tt   = t(5:50)-t(5);

om11=-om11';
om33=-om33';
tt=tt';

//plot(tt,om11);
//plot(tt,om33);

disp("Verifizierung der Winkelgeschw. mittels des Winkels:");

//Anpassung der Skalierung an phi:
om11=om11*0.01;
om33=om33*0.01;
//Winkelgeschwindigkeit integrieren:
zs=size(om11);
z=zs(1);
om11(z)=om11(z-1);
phi1=zeros(z,1);
phi11=0.0;
for i=2:z
  phi11=phi11+om11(i)*(tt(i)-tt(i-1));
  phi1(i)=phi11;
end

//plot(tt+totzeit,phi1,m1(:,1),-m1(:,2)+0.12);
t=tt;
om=om11;
zs=size(t);
z=zs(1);
plot(t,om);

s = poly(0,"s");
pa=0.1;
pb=10;
pc=250;
G = syslin('c',[1],[pa*s*s+pb*s+pc]);
u = 300*ones(z,1);

y   = csim(u',t',G);
plot(t,y(1,:));

function err=berechneFehler(x)
    pa=x(1);
    pb=x(2);
    pc=x(3);

    G = syslin('c',[1],[pa*s*s+pb*s+pc]);
    y = csim(u',t',G);
  

    err = sqrt( (om-y(1,:)')'*(om-y(1,:)')  );
endfunction

pa=0.1;
pb=10;
pc=250;
x0=[pa;pb;pc];

[fopt, xopt, gopt] = optim(list(NDcost,berechneFehler), "b", x0.*0.1, x0.*10.0, x0);

pa=xopt(1);
pb=xopt(2);
pc=xopt(3);
G = syslin('c',[1],[pa*s*s+pb*s+pc]);
y = csim(u',t',G);
plot(t,y(1,:));

disp("pa=");
disp(pa);
disp("pb=");
disp(pb);
disp("pc=");
disp(pc);
